<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2012 Herve Donati <herve.donati@ac-caen.fr>               |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/

include_once("../../include/config.php");
include_once("../../include/global.php");
include_once("../../lib/rrd.php");
include_once("top_general_header.php");

// Initialize
$ds_id       = $_SESSION["ds_id"]      = $_POST["ds_id"];
$date_start  = $_SESSION["date_start"] = $_POST["date_start"];
$date_end    = $_SESSION["date_end"]   = $_POST["date_end"];
$tspan       = $_SESSION["tspan"]      = $_POST["tspan"];
$units       = $_SESSION["units"]      = $_POST["units"];
$win         = $_SESSION["win"]        = $_POST["win"];
$type_ds     = $_SESSION["type_ds"]    = $_POST["type_ds"];
$type_pred   = $_SESSION["type_pred"]  = $_POST["type_pred"];
$col_ds      = $_SESSION["col_ds"]     = $_POST["col_ds"];
$col_pred    = $_SESSION["col_pred"]   = $_POST["col_pred"];
$width       = $_POST["width"];
$height      = $_POST["height"];
// To keep same host when going back
$_SESSION["host_id"] = $_POST["host_id"];
$time_period = array(
                3600     => "hour",
                86400    => "day",
                604800   => "week",
                2592000  => "month",
                31536000 => "year",
               );
$req_db      = "SELECT name_cache,data_source_path,data_source_name 
                FROM data_template_data,data_template_rrd 
                WHERE data_template_data.local_data_id=data_template_rrd.local_data_id AND 
                      data_template_rrd.id=$ds_id";
$ds_resreq   = db_fetch_row( $req_db );
$ds_name     = $ds_resreq["name_cache"];
$ds_path     =  str_replace('<path_rra>', $config['rra_path'], $ds_resreq["data_source_path"]);
$ds_var      = $ds_resreq["data_source_name"];

// File name hashed if possible
if ( extension_loaded( 'hash' ) ) {
    $hash_calc   = hash('md5', "$ds_id$date_start$date_end$tspan$units$win");
} else {
    $hash_calc = preg_replace('/\W/','',"$ds_id$date_start$date_end$tspan$units$win");
}
$file_name   = 'f_' . $hash_calc . '.png';
$file_rel    = $config['url_path'] . "plugins/predict/tmp/$file_name";
$file_abs    = $_SESSION["file_del"] = 'tmp/' . $file_name;

// Header
print "<TABLE width='100%'>\n";
print "    <TR bgcolor=" . $colors["header"] . ">\n";
print "        <TD colspan='3' class='textHeaderDark'>\n";
print "            <STRONG>DataSource</STRONG> <I>" . htmlspecialchars($ds_name) . "</I> <STRONG>behaviour between $date_start and $date_end</STRONG>\n";
print "        </TD>\n";
print "    </TR>\n";
print "    <TR>\n";
print "        <TD>\n";
print "            <SMALL>Prediction based on previous $units " . $time_period[$tspan] . "(s), window of $win seconds</SMALL>\n";
print "        </TD>\n";
print "    </TR>\n";

// Time values
$start     = strtotime($date_start);
$end       = strtotime($date_end);
$start_a   = $start-($units*$tspan);
// Display colors/types
$disp_a    = "$type_ds:a#$col_ds";
$disp_pred = "$type_pred:predict#$col_pred";
// Must increment unit (current timespan is included)
$units     = $units + 1;
// Build graph options
$gr_ops   = "--imgformat=PNG --title='$ds_name / $ds_var' --height=$height --width=$width --alt-autoscale-max --slope-mode --start=$start --end=$end DEF:a='$ds_path':$ds_var:AVERAGE:start=$start_a $disp_a:'collected value' CDEF:predict=$tspan,-$units,$win,a,PREDICT $disp_pred:'prediction'";
@rrdtool_execute("graph $file_abs $gr_ops", true, RRDTOOL_OUTPUT_NULL);
print "    <TR>\n";
print "        <TD>\n";
print '            <IMG src="' . $file_rel . '" alt="">';
print "        </TD>\n";
print "    </TR>\n";
print "</TABLE>\n";
?>
<TABLE>
    <TR>
    <INPUT type="button" name="button_back" value="Back" onclick="self.location.href='predict.php';"/>
    </TR>
</TABLE>
